Index: /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/filter.f90
===================================================================
--- /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/filter.f90	(revision 5212)
+++ /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/filter.f90	(revision 5213)
@@ -1232,46 +1248,4 @@
 
    END FUNCTION filter__2D_butterworth
-   !> @endcode
-!   !-------------------------------------------------------------------
-!   !> @brief This function 
-!   !
-!   !> @details
-!   !
-!   !> @author J.Paul
-!   !> - Nov, 2013- Initial Version
-!   !
-!   !> @param[in] 
-!   !-------------------------------------------------------------------
-!   !> @code
-!   FUNCTION filter_()
-!      IMPLICIT NONE
-!      ! Argument      
-!      ! function
-!      ! local variable
-!      ! loop indices
-!      !----------------------------------------------------------------
-!
-!   END FUNCTION filter_
-!   !> @endcode
-!   !-------------------------------------------------------------------
-!   !> @brief This subroutine 
-!   !
-!   !> @details
-!   !
-!   !> @author J.Paul
-!   !> - Nov, 2013- Initial Version
-!   !
-!   !> @param[in] 
-!   !-------------------------------------------------------------------
-!   !> @code
-!   SUBROUTINE filter_()
-!      IMPLICIT NONE
-!      ! Argument      
-!      ! local variable
-!      ! loop indices
-!      !----------------------------------------------------------------
-!
-!   END SUBROUTINE filter_
-!   !> @endcode
 END MODULE filter
 
Index: /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/function.f90
===================================================================
--- /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/function.f90	(revision 5212)
+++ /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/function.f90	(revision 5213)
@@ -7,14 +7,87 @@
 ! DESCRIPTION:
 !> @brief
-!> This module group some basic useful function
-!
+!> This module groups some basic useful function.
+!>
+!> @details
+!>  to get free I/O unit number:<br/>
+!> @code
+!>  il_id=fct_getunit()
+!> @endcode
+!>
+!>  to convert "numeric" to string character:<br/>
+!> @code
+!>  cl_string=fct_str(numeric)
+!> @endcode
+!>  - "numeric" could be integer, real, or logical
+!>
+!>  to concatenate "numeric" to a string character:<br/>
+!> @code
+!>  cl_str=cd_char//num
+!> @endcode
+!>  - cd_char is the string character
+!>  - num is the numeric value (integer, real or logical)  
+!>
+!>  to concatenate all the element of a character array:<br/> 
+!> @code
+!>  cl_string=fct_concat(cd_arr [,cd_sep])
+!> @endcode
+!>  - cd_arr is a 1D array of character
+!>  - cd_sep is a separator character to add between each element of cd_arr 
+!> [optional]
+!>
+!>  to convert character from lower to upper case:<br/>
+!> @code
+!>  cl_upper=fct_upper(cd_var)
+!> @endcode
+!>
+!>  to convert character from upper to lower case:<br/>
+!> @code
+!>  cl_lower=fct_lower(cd_var)
+!> @endcode
+!>
+!>  to check if character is numeric
+!> @code
+!>  ll_is_num=fct_is_num(cd_var)
+!> @endcode
+!>
+!>  to split string into substring and return one of the element:<br/>  
+!> @code
+!>  cl_str=fct_split(cd_string ,id_ind [,cd_sep])
+!> @endcode
+!>  - cd_string is a string of character
+!>  - id_ind is the indice of the lement to extract
+!>  - cd_sep is the separator use to split cd_string (default '|')
+!>
+!>  to get basename (name without path):<br/>
+!> @code
+!>  cl_str=fct_basename(cd_string [,cd_sep])
+!> @endcode
+!>  - cd_string is the string filename
+!>  - cd_sep is the separator ti be used (default '/')
+!>
+!>  to get dirname (path of the filename):<br/>
+!> @code
+!>  cl_str=fct_dirname(cd_string [,cd_sep])
+!> @endcode
+!>  - cd_string is the string filename
+!>  - cd_sep is the separator ti be used (default '/')
+!>  
+!> to create a pause statement:<br/>
+!> @code
+!> CALL fct_pause(cd_msg)
+!> @endcode
+!>    - cd_msg : message to be added [optional]
+!>
+!> to handle frotran error:<br/>
+!> @code
+!> CALL fct_err(id_status)
+!> @endcode
+!> 
+!> 
 !> @author
 !> J.Paul
 ! REVISION HISTORY:
-!> @date Nov, 2013 - Initial Version
-!
-!> @todo
-!> - TODO_describe_appropriate_changes - TODO_name
-!> @param MyModule_type : brief_description
+!> @date November, 2013 - Initial Version
+!> @date September, 2014 - add header
 !
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -23,19 +96,19 @@
    USE kind                            ! F90 kind parameter
    IMPLICIT NONE
-   PRIVATE
    ! NOTE_avoid_public_variables_if_possible
 
    ! function and subroutine
-   PUBLIC :: OPERATOR(//)
-   PUBLIC :: fct_getunit! returns free unit number
-   PUBLIC :: fct_err    ! handle fortran error status
-   PUBLIC :: fct_str    ! convert numeric to string character
-   PUBLIC :: fct_concat ! concatenate all the element of a character table
-   PUBLIC :: fct_upper  ! convert lower character to upper case
-   PUBLIC :: fct_lower  ! convert upper character to lower case
-   PUBLIC :: fct_is_num ! check if character is numeric
-   PUBLIC :: fct_split  ! split string into substring
-   PUBLIC :: fct_basename ! return basename (name without path)
-   PUBLIC :: fct_dirname ! return dirname (path without name)
+   PUBLIC :: fct_getunit  !< returns free unit number
+   PUBLIC :: fct_str      !< convert numeric to string character
+   PUBLIC :: OPERATOR(//) !< concatenate operator
+   PUBLIC :: fct_concat   !< concatenate all the element of a character array
+   PUBLIC :: fct_upper    !< convert character from lower to upper case
+   PUBLIC :: fct_lower    !< convert character from upper to lower case
+   PUBLIC :: fct_is_num   !< check if character is numeric
+   PUBLIC :: fct_split    !< split string into substring
+   PUBLIC :: fct_basename !< return basename (name without path)
+   PUBLIC :: fct_dirname  !< return dirname (path without filename)
+   PUBLIC :: fct_pause    !< pause statement
+   PUBLIC :: fct_err      !< handle fortran error status
 
    PRIVATE :: fct__i1_str ! convert integer(1) to string character
@@ -46,5 +119,12 @@
    PRIVATE :: fct__r8_str ! convert real(8) to string character
    PRIVATE :: fct__l_str  ! convert logical to string character
-
+   PRIVATE :: fct__i1_cat ! concatenate integer(1) to string character
+   PRIVATE :: fct__i2_cat ! concatenate integer(2) to string character
+   PRIVATE :: fct__i4_cat ! concatenate integer(4) to string character
+   PRIVATE :: fct__i8_cat ! concatenate integer(8) to string character
+   PRIVATE :: fct__r4_cat ! concatenate real(4) to string character
+   PRIVATE :: fct__r8_cat ! concatenate real(8) to string character
+   PRIVATE :: fct__l_cat  ! concatenate logical to string character
+   PRIVATE :: fct__split_space ! split string into substring using space as separator
 
    INTERFACE fct_str
@@ -59,4 +139,6 @@
 
    INTERFACE OPERATOR(//)
+      MODULE PROCEDURE fct__i1_cat ! concatenate integer(1) to string character
+      MODULE PROCEDURE fct__i2_cat ! concatenate integer(2) to string character
       MODULE PROCEDURE fct__i4_cat ! concatenate integer(4) to string character
       MODULE PROCEDURE fct__i8_cat ! concatenate integer(8) to string character
@@ -68,12 +150,61 @@
 CONTAINS
    !------------------------------------------------------------------- 
-   !> @brief This routine concatenate character and integer(4) (as character). 
+   !> @brief This function concatenate character and integer(1) (as character). 
+   ! 
+   !> @author J.Paul 
+   !> - September, 2014- Initial Version 
+   ! 
+   !> @param[in] cd_char   string character
+   !> @param[in] bd_val    integer(1) variable value
+   !> @return string character 
+   !------------------------------------------------------------------- 
+   PURE CHARACTER(LEN=lc) FUNCTION fct__i1_cat(cd_char, bd_val) 
+ 
+      ! arguments
+      CHARACTER(LEN=lc), INTENT(IN) :: cd_char
+      INTEGER(i1),       INTENT(IN) :: bd_val
+
+      ! local variable
+      CHARACTER(LEN=lc) :: cl_val
+      !---------------------------------------------------------------- 
+ 
+      cl_val = fct_str(bd_val)
+      fct__i1_cat=TRIM(cd_char)//TRIM(cl_val)
+
+   END FUNCTION fct__i1_cat 
+   !------------------------------------------------------------------- 
+   !> @brief This function concatenate character and integer(2) (as character). 
+   ! 
+   !> @author J.Paul 
+   !> - September, 2014- Initial Version 
+   ! 
+   !> @param[in] cd_char   string character
+   !> @param[in] sd_val    integer(2) variable value
+   !> @return string character 
+   !------------------------------------------------------------------- 
+   PURE CHARACTER(LEN=lc) FUNCTION fct__i2_cat(cd_char, sd_val) 
+ 
+      ! arguments
+      CHARACTER(LEN=lc), INTENT(IN) :: cd_char
+      INTEGER(i2),       INTENT(IN) :: sd_val
+
+      ! local variable
+      CHARACTER(LEN=lc) :: cl_val
+      !---------------------------------------------------------------- 
+ 
+      cl_val = fct_str(sd_val)
+      fct__i2_cat=TRIM(cd_char)//TRIM(cl_val)
+
+   END FUNCTION fct__i2_cat 
+   !------------------------------------------------------------------- 
+   !> @brief This function concatenate character and integer(4) (as character). 
    ! 
    !> @author J.Paul 
    !> - Nov, 2013- Initial Version 
    ! 
+   !> @param[in] cd_char   string character
+   !> @param[in] id_val    integer(4) variable value
    !> @return string character 
    !------------------------------------------------------------------- 
-   ! @code 
    PURE CHARACTER(LEN=lc) FUNCTION fct__i4_cat(cd_char, id_val) 
  
@@ -90,14 +221,14 @@
 
    END FUNCTION fct__i4_cat 
-   ! @endcode
-   !------------------------------------------------------------------- 
-   !> @brief This routine concatenate character and integer(8) (as character). 
+   !------------------------------------------------------------------- 
+   !> @brief This function concatenate character and integer(8) (as character). 
    ! 
    !> @author J.Paul 
-   !> - Nov, 2013- Initial Version 
+   !> - November, 2013- Initial Version 
    ! 
+   !> @param[in] cd_char   string character
+   !> @param[in] kd_val    integer(8) variable value
    !> @return string character 
    !------------------------------------------------------------------- 
-   ! @code 
    PURE CHARACTER(LEN=lc) FUNCTION fct__i8_cat(cd_char, kd_val) 
  
@@ -114,14 +245,14 @@
 
    END FUNCTION fct__i8_cat 
-   ! @endcode
-   !------------------------------------------------------------------- 
-   !> @brief This routine concatenate character and real(4) (as character). 
+   !------------------------------------------------------------------- 
+   !> @brief This function concatenate character and real(4) (as character). 
    ! 
    !> @author J.Paul 
-   !> - Nov, 2013- Initial Version 
+   !> - November, 2013- Initial Version 
    ! 
+   !> @param[in] cd_char   string character
+   !> @param[in] rd_val    real(4) variable value
    !> @return string character 
    !------------------------------------------------------------------- 
-   ! @code 
    PURE CHARACTER(LEN=lc) FUNCTION fct__r4_cat(cd_char, rd_val) 
  
@@ -138,14 +269,14 @@
 
    END FUNCTION fct__r4_cat 
-   ! @endcode
-   !------------------------------------------------------------------- 
-   !> @brief This routine concatenate character and real(8) (as character). 
-   ! 
+   !------------------------------------------------------------------- 
+   !> @brief This function concatenate character and real(8) (as character). 
+   !>
    !> @author J.Paul 
-   !> - Nov, 2013- Initial Version 
-   ! 
+   !> - November, 2013- Initial Version 
+   !>
+   !> @param[in] cd_char   string character
+   !> @param[in] dd_val    real(8) variable value
    !> @return string character 
    !------------------------------------------------------------------- 
-   ! @code 
    PURE CHARACTER(LEN=lc) FUNCTION fct__r8_cat(cd_char, dd_val) 
  
@@ -162,14 +293,14 @@
 
    END FUNCTION fct__r8_cat 
-   ! @endcode
-   !------------------------------------------------------------------- 
-   !> @brief This routine concatenate character and logical (as character). 
-   ! 
+   !------------------------------------------------------------------- 
+   !> @brief This function concatenate character and logical (as character). 
+   !>
    !> @author J.Paul 
-   !> - Nov, 2013- Initial Version 
-   ! 
+   !> - November, 2013- Initial Version 
+   !>
+   !> @param[in] cd_char   string character
+   !> @param[in] ld_val    logical variable value
    !> @return string character 
    !------------------------------------------------------------------- 
-   ! @code 
    PURE CHARACTER(LEN=lc) FUNCTION fct__l_cat(cd_char, ld_val) 
  
@@ -186,14 +317,12 @@
 
    END FUNCTION fct__l_cat 
-   ! @endcode
-   !------------------------------------------------------------------- 
-   !> @brief This routine returns the next available I/O unit number. 
-   ! 
+   !------------------------------------------------------------------- 
+   !> @brief This function returns the next available I/O unit number. 
+   !>
    !> @author J.Paul 
-   !> - Nov, 2013- Initial Version 
-   ! 
+   !> - November, 2013- Initial Version 
+   !>
    !> @return file id 
    !------------------------------------------------------------------- 
-   ! @code 
    INTEGER(i4) FUNCTION fct_getunit() 
  
@@ -211,12 +340,12 @@
  
    END FUNCTION fct_getunit 
-   ! @endcode
-   !-------------------------------------------------------------------
-   !> @brief This routine handle Fortran status.
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !-------------------------------------------------------------------
-   ! @code
+   !-------------------------------------------------------------------
+   !> @brief This subroutine handle Fortran status.
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[in] id_status
+   !-------------------------------------------------------------------
    SUBROUTINE fct_err(id_status)
 
@@ -232,15 +361,35 @@
 
    END SUBROUTINE fct_err
-   ! @endcode
+   !-------------------------------------------------------------------
+   !> @brief This subroutine  create a pause statement
+   !
+   !> @author J.Paul
+   !> - November, 2014- Initial Version
+   !>
+   !> @param[in] cd_msg optional message to be added
+   !-------------------------------------------------------------------
+   SUBROUTINE fct_pause(cd_msg)
+
+      ! Argument
+      CHARACTER(LEN=*), INTENT(IN), OPTIONAL  :: cd_msg
+      !----------------------------------------------------------------
+
+      IF( PRESENT(cd_msg) )THEN
+         WRITE( *, * ) 'Press Enter to continue '//TRIM(cd_msg)
+      ELSE
+         WRITE( *, * ) 'Press Enter to continue'
+      ENDIF
+      READ( *, * )
+
+   END SUBROUTINE fct_pause
    !-------------------------------------------------------------------
    !> @brief This function convert logical to string character.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] ld_var : logical variable
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] ld_var logical variable
    !> @return character of this integer variable
    !-------------------------------------------------------------------
-   ! @code
    PURE CHARACTER(LEN=lc) FUNCTION fct__l_str(ld_var)
       IMPLICIT NONE
@@ -256,15 +405,13 @@
 
    END FUNCTION fct__l_str
-   ! @endcode
    !-------------------------------------------------------------------
    !> @brief This function convert integer(1) to string character.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] bd_var : integer(1) variable
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] bd_var integer(1) variable
    !> @return character of this integer variable
    !-------------------------------------------------------------------
-   ! @code
    PURE CHARACTER(LEN=lc) FUNCTION fct__i1_str(bd_var)
       IMPLICIT NONE
@@ -280,15 +427,13 @@
 
    END FUNCTION fct__i1_str
-   ! @endcode
    !-------------------------------------------------------------------
    !> @brief This function convert integer(2) to string character.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] sd_var : integer(2) variable
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] sd_var integer(2) variable
    !> @return character of this integer variable
    !-------------------------------------------------------------------
-   ! @code
    PURE CHARACTER(LEN=lc) FUNCTION fct__i2_str(sd_var)
       IMPLICIT NONE
@@ -304,15 +449,13 @@
 
    END FUNCTION fct__i2_str
-   ! @endcode
    !-------------------------------------------------------------------
    !> @brief This function convert integer(4) to string character.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] id_var : integer(4) variable
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] id_var integer(4) variable
    !> @return character of this integer variable
    !-------------------------------------------------------------------
-   ! @code
    PURE CHARACTER(LEN=lc) FUNCTION fct__i4_str(id_var)
       IMPLICIT NONE
@@ -328,15 +471,13 @@
 
    END FUNCTION fct__i4_str
-   ! @endcode
    !-------------------------------------------------------------------
    !> @brief This function convert integer(8) to string character.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] kd_var : integer(8) variable
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] kd_var integer(8) variable
    !> @return character of this integer variable
    !-------------------------------------------------------------------
-   ! @code
    PURE CHARACTER(LEN=lc) FUNCTION fct__i8_str(kd_var)
       IMPLICIT NONE
@@ -352,15 +493,13 @@
 
    END FUNCTION fct__i8_str
-   ! @endcode   
    !-------------------------------------------------------------------
    !> @brief This function convert real(4) to string character.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] rd_var : real(4) variable
-   !> @return character of this integer variable
-   !-------------------------------------------------------------------
-   ! @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] rd_var real(4) variable
+   !> @return character of this real variable
+   !-------------------------------------------------------------------
    PURE CHARACTER(LEN=lc) FUNCTION fct__r4_str(rd_var)
       IMPLICIT NONE
@@ -376,15 +515,13 @@
 
    END FUNCTION fct__r4_str
-   ! @endcode   
    !-------------------------------------------------------------------
    !> @brief This function convert real(8) to string character.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] dd_var : real(8) variable
-   !> @return character of this integer variable
-   !-------------------------------------------------------------------
-   ! @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] dd_var real(8) variable
+   !> @return character of this real variable
+   !-------------------------------------------------------------------
    PURE CHARACTER(LEN=lc) FUNCTION fct__r8_str(dd_var)
       IMPLICIT NONE
@@ -400,22 +537,21 @@
 
    END FUNCTION fct__r8_str
-   ! @endcode   
-   !-------------------------------------------------------------------
-   !> @brief This function concatenate all the element of a character table 
-   !> except unknown one, in a character string.
-   !>
-   !> optionnally a separator could be added between each element
-   !>
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_tab : table of character
+   !-------------------------------------------------------------------
+   !> @brief This function concatenate all the element of a character array 
+   !> in a character string.
+   !> @details
+   !> optionnally a separator could be added between each element.
+   !>
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_arr array of character
+   !> @param[in] cd_sep separator character
    !> @return character
    !-------------------------------------------------------------------
-   ! @code
-   PURE CHARACTER(LEN=lc) FUNCTION fct_concat(cd_tab,cd_sep)
-      IMPLICIT NONE
-      ! Argument      
-      CHARACTER(*), DIMENSION(:), INTENT(IN) :: cd_tab
+   PURE CHARACTER(LEN=lc) FUNCTION fct_concat(cd_arr,cd_sep)
+      IMPLICIT NONE
+      ! Argument      
+      CHARACTER(*), DIMENSION(:), INTENT(IN) :: cd_arr
       CHARACTER(*),               INTENT(IN), OPTIONAL :: cd_sep
 
@@ -432,13 +568,10 @@
       IF(PRESENT(cd_sep)) cl_sep=cd_sep
 
-      il_size=SIZE(cd_tab)
+      il_size=SIZE(cd_arr)
       fct_concat=''
       cl_tmp=''
       DO ji=1,il_size
 
-         !IF( TRIM(ADJUSTL(cd_tab(ji))) /= 'unknown' )THEN
-            WRITE(cl_tmp,*) TRIM(fct_concat)//TRIM(ADJUSTL(cd_tab(ji)))//TRIM(cl_sep)
-         !ENDIF
-      
+         WRITE(cl_tmp,*) TRIM(fct_concat)//TRIM(ADJUSTL(cd_arr(ji)))//TRIM(cl_sep)
          fct_concat=TRIM(ADJUSTL(cl_tmp))
       
@@ -446,5 +579,4 @@
 
    END FUNCTION fct_concat
-   ! @endcode   
    !-------------------------------------------------------------------
    !> @brief This function convert string character upper case to lower case.
@@ -458,10 +590,9 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_var : character
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_var character
    !> @return lower case character
    !-------------------------------------------------------------------
-   ! @code
    PURE CHARACTER(LEN=lc) FUNCTION fct_lower(cd_var)
       IMPLICIT NONE
@@ -505,5 +636,4 @@
 
    END FUNCTION fct_lower
-   ! @endcode
    !-------------------------------------------------------------------
    !> @brief This function convert string character lower case to upper case.
@@ -517,10 +647,9 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_var : character
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_var character
    !> @return upper case character
    !-------------------------------------------------------------------
-   ! @code
    PURE CHARACTER(LEN=lc) FUNCTION fct_upper(cd_var)
       IMPLICIT NONE
@@ -564,17 +693,13 @@
 
    END FUNCTION fct_upper
-   ! @endcode   
    !-------------------------------------------------------------------
    !> @brief This function check if character is numeric.
    !
-   !> @details
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_var : character
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_var character
    !> @return character is numeric
    !-------------------------------------------------------------------
-   ! @code
    PURE LOGICAL FUNCTION fct_is_num(cd_var)
       IMPLICIT NONE
@@ -597,21 +722,17 @@
 
    END FUNCTION fct_is_num
-   ! @endcode
    !-------------------------------------------------------------------
    !> @brief This function split string of character 
    !> using separator character, by default '|',
-   !> and return the element on index ind
-   !
-   !> @details
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_string : string of character
-   !> @param[in] id_ind : indice
-   !> @param[in] cd_sep   separator character
+   !> and return the element on index ind.
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_string string of character
+   !> @param[in] id_ind    indice
+   !> @param[in] cd_sep    separator character
    !> @return return the element on index id_ind
    !-------------------------------------------------------------------
-   ! @code
    PURE FUNCTION fct_split(cd_string, id_ind, cd_sep)
       IMPLICIT NONE
@@ -629,4 +750,5 @@
 
       INTEGER(i4) :: il_sep
+      INTEGER(i4) :: il_lsep
       
       ! loop indices
@@ -639,13 +761,87 @@
       ! get separator
       cl_sep='|'
-      IF( PRESENT(cd_sep) ) cl_sep=TRIM(ADJUSTL(cd_sep))
+      IF( PRESENT(cd_sep) )THEN
+         IF( cd_sep==' ')THEN
+            cl_sep=' '
+         ELSE
+            cl_sep=TRIM(ADJUSTL(cd_sep))
+         ENDIF
+      ENDIF
       
+      IF( cl_sep /= ' ' )THEN
+         ! get separator index
+         il_sep=INDEX( TRIM(cl_string), TRIM(cl_sep) )
+         il_lsep=LEN(TRIM(cl_sep)) 
+
+         IF( il_sep /= 0 )THEN
+            fct_split=TRIM(ADJUSTL(cl_string(1:il_sep-1)))
+         ELSE
+            fct_split=TRIM(ADJUSTL(cl_string))
+         ENDIF
+
+         ji=1
+         DO WHILE( il_sep /= 0 .AND. ji /= id_ind )
+            
+            ji=ji+1
+            
+            cl_string=TRIM(cl_string(il_sep+il_lsep:))
+            il_sep=INDEX( TRIM(cl_string), TRIM(cl_sep) )
+
+            IF( il_sep /= 0 )THEN
+               fct_split=TRIM(ADJUSTL(cl_string(1:il_sep-1)))
+            ELSE
+               fct_split=TRIM(ADJUSTL(cl_string))
+            ENDIF
+
+         ENDDO
+
+         IF( ji /= id_ind ) fct_split=''
+      ELSE
+         fct_split=fct__split_space(TRIM(cl_string), id_ind)
+      ENDIF
+
+   END FUNCTION fct_split
+   !-------------------------------------------------------------------
+   !> @brief This function split string of character 
+   !> using space as separator, 
+   !> and return the element on index ind.
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_string string of character
+   !> @param[in] id_ind    indice
+   !> @return return the element on index id_ind
+   !-------------------------------------------------------------------
+   PURE FUNCTION fct__split_space(cd_string, id_ind)
+      IMPLICIT NONE
+      ! Argument      
+      CHARACTER(LEN=*), INTENT(IN) :: cd_string
+      INTEGER(i4)     , INTENT(IN) :: id_ind
+
+      ! function
+      CHARACTER(LEN=lc) :: fct__split_space
+
+      ! local variable
+      CHARACTER(LEN=lc) :: cl_string
+
+      INTEGER(i4) :: il_sep
+      INTEGER(i4) :: il_lsep
+      
+      ! loop indices
+      INTEGER(i4) :: ji
+      !----------------------------------------------------------------
+      ! initialize
+      fct__split_space=''
+      cl_string=ADJUSTL(cd_string)
+
       ! get separator index
-      il_sep=INDEX( TRIM(cl_string), TRIM(cl_sep) )
-      
+      il_sep=INDEX( TRIM(cl_string), ' ' )
+      il_lsep=LEN(' ') 
+
       IF( il_sep /= 0 )THEN
-         fct_split=TRIM(ADJUSTL(cl_string(1:il_sep-1)))
+         fct__split_space=TRIM(ADJUSTL(cl_string(1:il_sep-1)))
       ELSE
-         fct_split=TRIM(ADJUSTL(cl_string))
+         fct__split_space=TRIM(ADJUSTL(cl_string))
       ENDIF
 
@@ -655,33 +851,32 @@
          ji=ji+1
          
-         cl_string=TRIM(cl_string(il_sep+1:))
-         il_sep=INDEX( TRIM(cl_string), TRIM(cl_sep) )
+         cl_string=TRIM(cl_string(il_sep+il_lsep:))
+         il_sep=INDEX( TRIM(cl_string), ' ' )
 
          IF( il_sep /= 0 )THEN
-            fct_split=TRIM(ADJUSTL(cl_string(1:il_sep-1)))
+            fct__split_space=TRIM(ADJUSTL(cl_string(1:il_sep-1)))
          ELSE
-            fct_split=TRIM(ADJUSTL(cl_string))
+            fct__split_space=TRIM(ADJUSTL(cl_string))
          ENDIF
 
       ENDDO
 
-      IF( ji /= id_ind ) fct_split=''
-
-   END FUNCTION fct_split
-   ! @endcode
+      IF( ji /= id_ind ) fct__split_space=''
+
+   END FUNCTION fct__split_space
    !-------------------------------------------------------------------
    !> @brief This function return basename of a filename.
    !
    !> @details
-   !> actually it splits filename using sperarator '/'
-   !> and return last string character
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_string : filename
+   !> Actually it splits filename using sperarator '/'
+   !> and return last string character.<br/>
+   !> Optionally you could specify another separator.
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_string filename
+   !> @param[in] cd_sep    separator character
    !> @return basename (filename without path)
    !-------------------------------------------------------------------
-   ! @code
    PURE FUNCTION fct_basename(cd_string, cd_sep)
       IMPLICIT NONE
@@ -711,19 +906,18 @@
 
    END FUNCTION fct_basename
-   ! @endcode
    !-------------------------------------------------------------------
    !> @brief This function return dirname of a filename.
    !
    !> @details
-   !> actually it splits filename using sperarator '/'
-   !> and return all exept last string character
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] cd_string : filename
+   !> Actually it splits filename using sperarator '/'
+   !> and return all except last string character.<br/>
+   !> Optionally you could specify another separator.
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] cd_string filename
+   !> @param[in] cd_sep    separator character
    !> @return dirname (path of the filename)
    !-------------------------------------------------------------------
-   ! @code
    PURE FUNCTION fct_dirname(cd_string, cd_sep)
       IMPLICIT NONE
@@ -757,5 +951,4 @@
 
    END FUNCTION fct_dirname
-   ! @endcode
 END MODULE fct
 
